#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xjf rpcbind-git20121230.tar.bz2
    cd rpcbind-git20121230
    # FIXME: The svc_auth_none.patch will reapply if this script is rerun
    #        without deleting the soruce code directory first, very confusing!
    bunzip2 -c ../rpcbind-git20121230-svc_auth_none.patch.bz2 | patch -p1 -b
    bunzip2 -c ../rpcbind-git20121230-missing_etcservices.patch.bz2 | patch \
	    -p1 -b
    ./autogen.sh
    ./configure --prefix=/usr --sysconfdir=/etc/X11 --localstatedir=/var \
	     --datadir=/usr/lib --with-rpcuser=daemon --enable-warmstarts
    make
    strip -R .note -R .comment rpcbind
    mkdir -p ../rpcbind/sbin
    cp rpcbind ../rpcbind/sbin/
    cd ..
    rm -rf rpcbind-git20121230
}

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
